package cs2114.tipcalculator;

import sofia.app.Screen;
import android.widget.EditText;
import android.widget.TextView;

//-------------------------------------------------------------------------
/**
 * Instructor solution to the GUI portion of Lab 03: Tip Calculator (Sofia
 * version).
 * 
 * @author  Tony Allevato
 * @version 2012.09.11
 */
public class TipCalculatorScreen extends Screen
{
	//~ Fields ................................................................

	private TipCalculator tipper;

	private EditText amountOfBill;
	private TextView tipAmount;


	//~ Public methods ........................................................

	// ----------------------------------------------------------
	/**
	 * Called before the screen appears to initialize any required data.
	 */
	public void initialize()
	{
		tipper = new TipCalculator();
		tipper.addObserver(this);
		
		tipper.setTipRate(0.15);
	}


	// ----------------------------------------------------------
	/**
	 * Called when the 15% tip button (ID tip15) is clicked.
	 */
	public void tip15Clicked()
	{
		tipper.setTipRate(0.15);
	}
	
	
	// ----------------------------------------------------------
	/**
	 * Called when the 18% tip button (ID tip18) is clicked.
	 */
	public void tip18Clicked()
	{
		tipper.setTipRate(0.18);
	}
	
	
	// ----------------------------------------------------------
	/**
	 * Called when the 20% tip button (ID tip20) is clicked.
	 */
	public void tip20Clicked()
	{
		tipper.setTipRate(0.20);
	}
	
	
	// ----------------------------------------------------------
	/**
	 * Called when the user has completed typing a value into the amountOfBill
	 * text field.
	 */
	public void amountOfBillEditingDone()
	{
		double amount = Double.parseDouble(amountOfBill.getText().toString());
		tipper.setAmountOfBill(amount);
	}
	
	
	// ----------------------------------------------------------
	/**
	 * Called when the state of the tip calculator has changed (due to
	 * interaction with one of the other widgets).
	 * 
	 * @param theTipper the TipCalculator that changed
	 */
	public void changeWasObserved(TipCalculator theTipper)
	{
		double tip = tipper.getTipAmount();
		tipAmount.setText(String.format("$%.2f", tip));
	}
}
