package cs2114.flashlight;

import sofia.app.ShapeScreen;
import sofia.graphics.Color;
import sofia.graphics.OvalShape;
import sofia.graphics.RectangleShape;
import android.view.MotionEvent;

//-------------------------------------------------------------------------
/**
 * The controller for the Flashlight lab.
 * 
 * @author  Tony Allevato
 * @version 2012.10.03
 */
public class FlashlightScreen extends ShapeScreen
{
	//~ Fields ................................................................

	private OvalShape light;
	private RectangleShape whiteBox;
	private RectangleShape redBox;
	private RectangleShape greenBox;
	private RectangleShape blueBox;

	private static final int BOX_SIZE = 25;
	private static final int LIGHT_RADIUS = 50;


	//~ Public methods ........................................................

	// ----------------------------------------------------------
	public void initialize()
	{
		setBackgroundColor(Color.black);

		float width = getWidth();
		float height = getHeight();

		whiteBox = new RectangleShape(0, 0, BOX_SIZE, BOX_SIZE);
		whiteBox.setFilled(true);
		whiteBox.setColor(Color.white);
		add(whiteBox);

		redBox = new RectangleShape(width - BOX_SIZE, 0, width, BOX_SIZE);
		redBox.setFilled(true);
		redBox.setColor(Color.red);
		add(redBox);
		
		greenBox = new RectangleShape(0, height - BOX_SIZE, BOX_SIZE, height);
		greenBox.setFilled(true);
		greenBox.setColor(Color.green);
		add(greenBox);

		blueBox = new RectangleShape(width - BOX_SIZE, height - BOX_SIZE,
				width, height);
		blueBox.setFilled(true);
		blueBox.setColor(Color.blue);
		add(blueBox);
	}
	
	
	// ----------------------------------------------------------
	public void onTouchDown(MotionEvent e)
	{
		light = new OvalShape(e.getX(), e.getY(), LIGHT_RADIUS);
		light.setFilled(true);
		light.setColor(Color.white);
		add(light);
	}
	
	
	// ----------------------------------------------------------
	public void onTouchMove(MotionEvent e)
	{
		light.setPosition(e.getX() - LIGHT_RADIUS, e.getY() - LIGHT_RADIUS);
	}
	
	
	// ----------------------------------------------------------
	public void onTouchUp(MotionEvent e)
	{
		light.animate(500).alpha(0).removeWhenComplete().play();
	}
	
	
	// ----------------------------------------------------------
	public void onCollisionBetween(OvalShape theLight, RectangleShape box)
	{
		theLight.animate(500).color(box.getColor()).play();
	}
}
