package cs2114.flashlight;

import sofia.graphics.Color;
import sofia.graphics.OvalShape;
import sofia.graphics.ShapeView;

//-------------------------------------------------------------------------
/**
 * Sample tests for the Flashlight lab.
 * 
 * @author  Tony Allevato
 * @version 2012.10.03
 */
public class FlashlightScreenTests
	extends student.AndroidTestCase<FlashlightScreen>
{
	//~ Fields ................................................................

	private ShapeView shapeView;
	private int width;
	private int height;


	//~ Constructors ..........................................................

	// ----------------------------------------------------------
	public FlashlightScreenTests()
	{
		super(FlashlightScreen.class);
	}
	

	//~ Public methods ........................................................

	// ----------------------------------------------------------
	public void setUp()
	{
		shapeView = getScreen().getShapeView();
		width = shapeView.getWidth();
		height = shapeView.getHeight();
	}


	// ----------------------------------------------------------
	public void testTouchDown()
	{
		touchDown(shapeView, width / 2, height / 2);

		OvalShape light = shapeView.getShapeAt(
				width / 2, height / 2, OvalShape.class);
		assertNotNull(light);
		assertEquals(Color.white, light.getColor());
	}


	// ----------------------------------------------------------
	public void testFadeOut()
	{
		touchDown(shapeView, width / 2, height / 2);
		touchUp();

		OvalShape light = shapeView.getShapeAt(
				width / 2, height / 2, OvalShape.class);
		assertNull(light);
	}


	// ----------------------------------------------------------
	public void testChangeToRed()
	{
		touchDown(shapeView, width / 2, height / 2);
		touchMove(width, 0);

		OvalShape light = shapeView.getShapeAt(width, 0, OvalShape.class);
		assertNotNull(light);
		assertEquals(Color.red, light.getColor());
	}
}
